package lect.ctx;

/**
 * JLS 6
 * Names in programs are either simple, consisting of a single identifier, 
 * or qualified, consisting of a sequence of identifiers separated by "." 
 * 
 * RULE: After "extends" (in that context) name must
 * denote a class
 * - If not a compiler error
 * 
 * JLS 8.4
 * "[Class] Methods and fields may have the same name, 
 * since they are used in different contexts"
 * - A method name is before '(' in an expression
 * @author hajo
 *
 */
public class TestContextForNames extends SomeName {
	// Bad should be lower case 
	// This is not a name. It's a declaration of a name (for later use) 
	public int SomeName;
	
	// Bad should be lower case 
	public void SomeName(){
	}
	
	// Qualified name TestContextForNames.SomeName
	public class SomeName{	
	};
	
	/* No, same as enclosing
	public class TestContextForNames{
	}*/
	
	// ctor
	public TestContextForNames(){
		System.out.println(new SomeName());
	}
	
}
