package lect.scope;

/**
 * Name 'i' used in many scopes
 * (what about 'i' in supe class)
 * 
 * @author hajo
 *
 */
public class TestScopes {

	public int i = 100;

	class Inner {
		int i = 50;

		public void dotIt() {
			System.out.println(i); // No 'i' in this block ... search enclosing blocks
		}
	}

	public void doIt(int i) {
		for (i = 0; i < 5; i++) {
			System.out.print(i + " ");
		}
		System.out.println();  
		i++;                   // Value of 'i'?
		System.out.println(i);
	}

	public void doOther() {
		for (int i = 0; i < 5; i++) { // Shadowing
			System.out.print(i + " ");
		}
		System.out.println(); 
		i++;                   // Value of 'i'?
		System.out.println(i);
	}
	
	public TestScopes(){
		doOther();
		doIt(55);
		new Inner().dotIt();
	}

}
